package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksIsi;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface RksIsiRepository extends JpaRepository<RksIsi, Long> {

    Page<RksIsi> findByRksDaftarIsiIdAndIsDeleteFalse(Long rksDaftarIsiId, Pageable pageable);

    Optional<RksIsi> findByRksDaftarIsiIdAndNamaAndIsDeleteFalse(Long rksDaftarIsiId, String nama);

    Optional<RksIsi> findByRksDaftarIsiIdAndBabAndIsDeleteFalse(Long rksDaftarIsiId, String bab);

    Optional<RksIsi> findByRksDaftarIsiIdAndSubBabAndIsDeleteFalse(Long rksDaftarIsiId, String subBab);

    Optional<RksIsi> findByRksDaftarIsiIdAndKelompokAndIsDeleteFalse(Long rksDaftarIsiId, String kelompok);

    Optional<RksIsi> findByIdAndIsDeleteFalse(Long id);

    @Query(value = "SELECT ri " +
            "FROM RksIsi ri " +
            "WHERE ri.isDelete = false " +
            "AND ri.parentId = 0")
    List<RksIsi> findByParentRksDaftarIsi(Long rksDaftarIsiId);

    @Modifying
    @Query(value = "UPDATE rks_isi " +
            "SET is_delete = 1 " +
            "WHERE rks_daftar_isi_id = :rksDaftarIsiId", nativeQuery = true)
    void deleteRksIsi(@Param("rksDaftarIsiId") Long rksDaftarIsiId);
}
